
// set giu mode to auto by default
document.plugInfo = {dark: 0};

function OnArbitraryMessage(msgTag, msgVal) {
  msgVal = atob(msgVal);
  switch (msgTag) {
    case -2:
      document.plugInfo = JSON.parse(msgVal);
      document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace("{plugInfo.version}", document.plugInfo.version);
      document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace("{plugInfo.buildDate}", document.plugInfo.buildDate);
      document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace("{plugInfo.copyright}", document.plugInfo.copyright);
      
      var elements = document.getElementsByClassName("track-name");
      Array.from(elements).forEach((el) => {
        el.innerHTML = document.plugInfo.trackname;
        if(document.plugInfo.trackname == "") {
          el.innerHTML = "Track with no name";
        }
      });
      
      handleUIModeChange(document.plugInfo.dark);
      break;
      
     // presets
     case 200:
        var userPresets = JSON.parse(msgVal);
        
        var presets = document.getElementById("presets");
        presets.innerHTML = "<option disabled><b>Factory Presets</b></option>";
        document.plugInfo.factoryPresets.forEach((preset) => {
            var option = document.createElement("option");
            option.value = preset;
            option.classList.add("factory-preset");
            option.innerHTML = preset;
            presets.appendChild(option);
        });
        var option = document.createElement("option");
        option.disabled = true;
        option.innerHTML = "<b>User Presets</b>";
        presets.appendChild(option);
        userPresets.forEach((preset) => {
            var option = document.createElement("option");
            option.value = preset;
            option.classList.add("user-preset");
            option.innerHTML = preset;
            presets.appendChild(option);
        });
        presets.addEventListener("change", (event) => {
            if(event.target.selectedOptions[0].className == "factory-preset") {
                SAMFUI(100, ctrlTag = -1, event.target.value);
                document.querySelector("#loadPresetModal .btn-close").dispatchEvent(new Event("click"));
            } else {
                SAMFUI(101, ctrlTag = -1, event.target.value);
                document.querySelector("#loadPresetModal .btn-close").dispatchEvent(new Event("click"));
            }
            console.log(event.target);
        });
      break;
      
  }
}

function handleUIModeChange(mode) {
  // set dark mode according to preferences
  if(mode == 1) {
    // light  or dark mode
    document.getElementsByTagName('html')[0].setAttribute('data-bs-theme', 'light');
  } else if (mode == 2) {
    // dark mode
    document.getElementsByTagName('html')[0].setAttribute('data-bs-theme', 'dark');
  } else if (mode == 0) {
    // auto mode
    const media = window.matchMedia('(prefers-color-scheme: dark)');
    const scheme = media.matches
      ? 'dark'
      : 'light'
    document.getElementsByTagName('html')[0].setAttribute('data-bs-theme', scheme);
  }
}


addEventListener('DOMContentLoaded', (event) => {

  addEventListener('ControlChange', (event)=> {
    GetControlByMessageId(event.detail.tag).forEach(function(elem){
      elem.setValue(event.detail.value);
    });
  });
    
  // save preset action
  document.getElementById('savePresetModalOk').addEventListener('click', (event)=> {
    SAMFUI(102,-1,document.getElementById('presetName').value);
  });

  // handle color theme change from dark to light
  const media = window.matchMedia("(prefers-color-scheme: dark)");
  media.addEventListener("change", function(){
    handleUIModeChange(document.plugInfo.dark);
  });
  
  // handle update of graph display
  
  function updateDisplay() {
    var lenghtNorm = GetControlByParamId(3)[0].getValue();
    if(lenghtNorm < 0.01) lenghtNorm = 0.01;
    var scale = "scale("+lenghtNorm+",1) ";
    var preNorm = GetControlByParamId(7)[0].getValue();
    preNorm *= 25 * (1/lenghtNorm);
    var translate = "translate("+preNorm+",1)";
    document.getElementsByClassName('triangle-decay')[0].setAttribute("transform",scale+translate);
  }
  
  GetControlByParamId(3)[0].setChangeCallback(updateDisplay);
  GetControlByParamId(7)[0].setChangeCallback(updateDisplay);
    
});

document.getElementById('aboutModal').addEventListener('shown.bs.modal', function () {
  
  // set mode droptown to current value
  document.getElementById("dark").value = document.plugInfo.dark;
  
  function updatePreferences() {

    // Create an object to hold the name/value pairs
    const pairs = {
      dark: document.getElementById("dark").value,
    };
    // Return the JSON string
    SAMFUI(999,-1,JSON.stringify(pairs));
  }
  
  // listen color mode change from preferences ui
  document.getElementById("dark").addEventListener("change", function() {
    handleUIModeChange(this.value);
    updatePreferences();
  });
});
